diff --git a/licenses/bsd.pt-br.po b/licenses/bsd.pt-br.po
index c6ab080..50f9dca 100644
--- a/licenses/bsd.pt-br.po
+++ b/licenses/bsd.pt-br.po
@@ -1,29 +1,30 @@
 # Brazilian Portuguese translation of http://www.gnu.org/licenses/bsd.html
-# Copyright (C) 2002 Free Software Foundation, Inc.
-# This file is distributed under the same license as the PACKAGE package.
-# Hilton Fernandes, 2002.
+# Copyright (C) 2017 Free Software Foundation, Inc.
+# This file is distributed under the same license as the original article.
+# Hilton Fernandes <fernandesh@yahoo.com>, 2002.
 # Jan 2015: GNUNify and trivially update a few strings (T. Godefroy).
-#
+# Rafael Fontenelle <rafaelff@gnome.org>, 2017.
 msgid ""
 msgstr ""
 "Project-Id-Version: bsd.html\n"
 "POT-Creation-Date: 2015-12-19 22:55+0000\n"
-"PO-Revision-Date: 2015-01-20 21:20+0100\n"
-"Last-Translator: Thérèse Godefroy <godef.th AT free.fr>\n"
-"Language-Team: web-translators <web-translators@gnu.org>\n"
+"PO-Revision-Date: 2017-04-06 04:51-0300\n"
+"Last-Translator: Rafael Fontenelle <rafaelff@gnome.org>\n"
+"Language-Team: Brazilian Portuguese <www-pt-br-general@gnu.org>\n"
 "Language: pt_BR\n"
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=utf-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"Outdated-Since: 2002-06-21 09:55+0000\n"
+"Plural-Forms: nplurals=2; plural=(n > 1);\n"
+"X-Generator: Virtaal 1.0.0-beta1\n"
 
 #. type: Content of: <title>
 msgid "BSD License Problem - GNU Project - Free Software Foundation"
-msgstr "O problema da Licença BSD - Projeto GNU - Free Software Foundation"
+msgstr "O Problema da Licença BSD - Projeto GNU - Free Software Foundation"
 
 #. type: Content of: <h2>
 msgid "The BSD License Problem"
-msgstr "O problema da Licença BSD"
+msgstr "O Problema da Licença BSD"
 
 #. type: Content of: <blockquote><p>
 msgid ""
@@ -31,20 +32,10 @@ msgid ""
 "a license for your own work&rdquo;</a> for general recommendations about "
 "choosing a license for your work."
 msgstr ""
+"Veja <a href=\"/licenses/license-recommendations.html\">“Como escolher uma "
+"licença para sua própria obra”</a> para recomendações gerais."
 
 #. type: Content of: <p>
-#, fuzzy
-#| msgid ""
-#| "The two major categories of free software license are <a href=\"/copyleft/"
-#| "copyleft.html\">copyleft</a> and <a href=\"/philosophy/categories."
-#| "html#Non-CopyleftedFreeSoftware\"> non-copyleft </a>.  <a href=\"/"
-#| "licenses/license-list.html#GPLCompatibleLicenses\">Copyleft licenses</a> "
-#| "such as the <a href=\"/licenses/gpl.html\">GNU GPL</a> insist that "
-#| "modified versions of the program must be free software as well.  Non-"
-#| "copyleft licenses do not insist on this.  <a href=\"/philosophy/why-"
-#| "copyleft.html\">We recommend copyleft</a>, because it protects freedom "
-#| "for all users, but non-copylefted software can still be free software, "
-#| "and useful to the free software community."
 msgid ""
 "The two major categories of free software license are <a href=\"/copyleft/"
 "copyleft.html\">copyleft</a> and <a href=\"/philosophy/categories.html#Non-"
@@ -56,18 +47,17 @@ msgid ""
 "a>, because it protects freedom for all users, but non-copylefted software "
 "can still be free software, and useful to the free software community."
 msgstr ""
-"As duas grandes categorias de software livre são as de softwares com <a href="
-"\"/copyleft/copyleft.html\">copyleft</a> e <a href=\"/philosophy/categories."
+"As duas grandes categorias de software livre são as de softwares <a href=\"/"
+"copyleft/copyleft.html\">com copyleft</a> e <a href=\"/philosophy/categories."
 "html#Non-CopyleftedFreeSoftware\"> sem copyleft</a>. <a href=\"/licenses/"
 "license-list.html#GPLCompatibleLicenses\">Licenças com copyleft</a> como a "
-"<a href=\"/copyleft/gpl.html\">GPL do GNU</a> insistem que versões "
-"modificadas do software também sejam software livre. <a href=\"/philosophy/"
-"why-copyleft.html\">Nós recomendamos o copyleft</a>, pois ele protege a "
-"liberdade para todos os usuários, mas o software sem copyleft pode mesmo "
-"assim ser software livre, e ser útil para a comunidade do software livre."
+"<a href=\"/copyleft/gpl.html\">GNU GPL</a> insistem que versões modificadas "
+"do software também sejam software livre. <a href=\"/philosophy/why-copyleft."
+"html\">Nós recomendamos o copyleft</a>, pois ele protege a liberdade para "
+"todos os usuários, mas o software sem copyleft pode mesmo assim ser software "
+"livre, e ser útil para a comunidade do software livre."
 
 #. type: Content of: <p>
-#, fuzzy
 msgid ""
 "There are many variants of simple <a href=\"/licenses/license-list."
 "html#GPLCompatibleLicenses\">non-copyleft free software licenses</a>, such "
@@ -79,15 +69,17 @@ msgid ""
 "include a particular sentence:"
 msgstr ""
 "Existem muitas variantes das licenças simples de <a href=\"/licenses/license-"
-"list.html#GPLCompatibleLicenses\">software livre sem copyleft</a>, como por "
-"exemplo a licença Expat, a licença FreeBSD, a licença do X10, a licença do "
-"X11, e as duas licenças do BSD, de <cite>Berkeley Software Distribution</"
-"cite>, ou “Distribuição de Software de Berkeley”. A maioria delas é "
-"equivalente, com exceção de detalhes das palavras escolhidas. Contudo, a "
-"licença usada pela BSD até 1999 tinha um problema em particular: a “cláusula "
-"deletéria de anúncio da licença do BSD”. Ela dizia que todo anúncio "
-"mencionando o software deveria incluir a seguinte licença:"
+"list.html#GPLCompatibleLicenses\">software livre sem copyleft</a>, como, por "
+"exemplo, a licença Expat, a licença FreeBSD, a licença do X10, a licença do "
+"X11, e as duas licenças do BSD (<cite>Berkeley Software Distribution</cite> "
+"ou “Distribuição de Software de Berkeley”). A maioria delas é equivalente, "
+"com exceção de detalhes das palavras escolhidas. Contudo, a licença usada "
+"pela BSD até 1999 tinha um problema em particular: a “cláusula deletéria de "
+"anúncio da licença BSD”. Ela dizia que todo anúncio mencionando o software "
+"deveria incluir a seguinte licença:"
 
+# Mantive o original junto com a versão portuguesa, pois trata-se de texto
+# legal, ou seja, o texto original que seria incluído no software -- Rafael
 #. type: Content of: <pre>
 #, no-wrap
 msgid ""
@@ -96,6 +88,13 @@ msgid ""
 "     This product includes software developed by the University of\n"
 "     California, Berkeley and its contributors.\n"
 msgstr ""
+"3. All advertising materials mentioning features or use of this software\n"
+"   must display the following acknowledgement:\n"
+"     This product includes software developed by the University of\n"
+"     California, Berkeley and its contributors.\n"
+"\n"
+"Isso pode ser traduzido para português como:\n"
+"\n"
 "3. Todos materiais de propaganda mencionando recursos ou uso deste\n"
 "   software devem fazer o seguinte reconhecimento: \n"
 "     Este produto inclui software desenvolvido pela Universidade da\n"
@@ -129,13 +128,12 @@ msgid ""
 "with their own institution or their own names.  The result is a plethora of "
 "licenses, requiring a plethora of different sentences."
 msgstr ""
-"Mas, se como é de se esperar, outros desenvolvedores não copiavam "
-"literalmente a cláusula do BSD. Eles a alteravam, trocando “Universidade da "
-"Califórnia” por sua própria instituição, ou por seus nomes. O resultado foi "
-"uma pletora de licenças, que requeriam uma pletora de sentenças diferentes."
+"Mas, como é de se esperar, outros desenvolvedores não copiavam literalmente "
+"a cláusula do BSD. Eles a alteravam, trocando “Universidade da Califórnia” "
+"por sua própria instituição, ou por seus nomes. O resultado foi uma pletora "
+"de licenças, que requeriam uma pletora de sentenças diferentes."
 
 #. type: Content of: <p>
-#, fuzzy
 msgid ""
 "When people put many such programs together in an operating system, the "
 "result is a serious problem.  Imagine if a software system required 75 "
@@ -149,18 +147,15 @@ msgstr ""
 "necessário um anúncio de página inteira."
 
 #. type: Content of: <p>
-#, fuzzy
-#| msgid ""
-#| "This might seem like extrapolation ad absurdum, but it is actual fact.  "
-#| "In a 1997 version of NetBSD, I counted 75 of these sentences."
 msgid ""
 "This might seem like extrapolation ad absurdum, but it is actual fact.  In a "
 "1997 version of NetBSD, I counted 75 of these sentences.  (Fortunately "
 "NetBSD has decided to stop adding them, and to remove those it could.)"
 msgstr ""
-"Isto pode parecer uma extrapolação <i>ad absurdum</i>, ou “ao absurdo”, mas "
-"é um fato. Em uma versão de 1997 do NetBSD, cheguei a contar 75 dessas "
-"frases."
+"Isto pode parecer uma extrapolação <i>ad absurdum</i><sup><a href="
+"\"#TransNote1\">1</a></sup>, mas é um fato. Em uma versão de 1997 do NetBSD, "
+"cheguei a contar 75 dessas frases. (Felizmente, NetBSD decidiu parar de "
+"adicioná-las, e poderia remover todas elas.)"
 
 #. type: Content of: <p>
 msgid ""
@@ -202,9 +197,9 @@ msgstr ""
 "Deste modo, hoje há uma nova licença BSD que não contém a cláusula do "
 "anúncio. Infelizmente, isto não elimina o legado da cláusula do anúncio: "
 "cláusulas similares ainda estão presentes em muitos pacotes que não são "
-"parte do BSD. A mudança na licença do BSD não tem efeito em outros pacotes "
-"cuja licença imita antiga licença do BSD; apenas os desenvolvedores que os "
-"criaram podem alterá-las."
+"parte do BSD. A mudança na licença BSD não tem efeito em outros pacotes cuja "
+"licença imita antiga licença BSD; apenas os desenvolvedores que os criaram "
+"podem alterá-las."
 
 #. type: Content of: <p>
 msgid ""
@@ -221,12 +216,11 @@ msgid ""
 "advertising clause, please ask the maintainer to look at this web page, and "
 "consider making the change."
 msgstr ""
-"Por isso, se você tiver um pacote favorito que ainda usa uma licencça no "
-"estilo BSD com a cláusula de anúncio, faça o favor de pedir a seu mantenedor "
-"que leia esta página na Web e considere fazer a alteração."
+"Por isso, se você tiver um pacote favorito que ainda usa uma licença BSD com "
+"a cláusula de anúncio, por favor peça a seu mantenedor que leia esta página "
+"na Web e considere fazer a alteração."
 
 #. type: Content of: <p>
-#, fuzzy
 msgid ""
 "And if you want to release a program as non-copylefted free software, please "
 "don't use the advertising clause.  Thus, instead of copying the BSD license "
@@ -235,21 +229,11 @@ msgid ""
 "such as Expat or FreeBSD."
 msgstr ""
 "E se você quiser lançar um programa como software livre sem copyleft, não "
-"use a cláusula de anúncio. Em vez de copiar a licença do BSD e algum pacote "
-"já lançado – que pode ainda usar a antiga versão da licença – por favor use "
-"uma das outras licenças permissivas, como por exemplo Expat ou XFree86."
+"use a cláusula de anúncio. Em vez de copiar a licença BSD de algum pacote já "
+"lançado – que pode ainda usar a antiga versão da licença –, por favor use "
+"uma das outras licenças permissivas, como por exemplo Expat ou FreeBSD."
 
 #. type: Content of: <p>
-#, fuzzy
-#| msgid ""
-#| "You can also help spread awareness of the issue by not calling a license "
-#| "``BSD-style'' unless you mean specifically the old BSD license with its "
-#| "troublesome advertising clause. You see, when people refer to all non-"
-#| "copyleft free software licenses as ``BSD licenses'', some new free "
-#| "software developer who wants to use a non-copyleft free software license "
-#| "might take for granted that the place to get it is from BSD. He or she "
-#| "might copy the license with the advertising clause, not as a firm "
-#| "decision, but just by default."
 msgid ""
 "You can also help spread awareness of the issue by not using the term &ldquo;"
 "BSD-style&rdquo;, and not saying &ldquo;the BSD license&rdquo; which implies "
@@ -260,17 +244,15 @@ msgid ""
 "might copy the license with the advertising clause, not by specific "
 "intention, just by chance."
 msgstr ""
-"Você tambêm pode ajudar a esclarecer o problema, se passar a dizer que uma "
-"licença segue o “estilo BSD” apenas se ela seguir a antiga licença do BSD, "
-"com sua problemática cláusula de anúncio. Você sabe, quando as pessoas se "
-"referem a licenças de software livre que não tenham copyleft, como “licenças "
-"BSD”, isto pode fazer com que algum novo desenvolvedor de software livre, "
-"que queira adotar uma licença sem copyleft pode supor que o lugar para obter "
-"isso é o BSD. E ele pode copiar a licença com a cláusula de anúncio, não "
-"conscientemente, mas apenas por má informação."
+"Você também pode ajudar a esclarecer o problema não usando o termo “estilo "
+"BSD” e não dizendo “a licença BSD”, o que implica em dizer que há apenas "
+"uma. Sabe, quando as pessoas se referem a todas as licenças de software "
+"livre que não tenham copyleft como “licenças no estilo BSD”, algum novo "
+"desenvolvedor de software livre, que queira adotar uma licença sem copyleft, "
+"pode supor que o lugar para obter isso é o BSD. E ele/ela pode copiar acabar "
+"por escolher a licença com a cláusula de anúncio, não intencionalmente."
 
 #. type: Content of: <p>
-#, fuzzy
 msgid ""
 "If you would like to cite one specific example of a non-copyleft license, "
 "and you have no particular preference, please pick an example which has no "
@@ -281,10 +263,10 @@ msgid ""
 msgstr ""
 "Se você quiser citar um exemplo específico de uma licença sem copyleft, e "
 "não tiver uma preferência em especial, por favor pegue um exemplo que não "
-"tem um problema a priori. For exemplo, se você falar de “licenças no estilo "
-"do X11”, você vai encorajar as pessoas a copiar a licença do X11 o que, com "
-"certeza, evita a cláusula de anúncio, em vez de correr o risco de escolher "
-"aleatoriamente um das licenças do BSD."
+"tenha um problema a priori. For exemplo, se você falar de “licenças no "
+"estilo X11”, você vai encorajar as pessoas a copiar a licença do X11, o que "
+"com certeza evita a cláusula de anúncio, em vez de correr o risco de "
+"escolher aleatoriamente um das licenças do BSD."
 
 #. type: Content of: <p>
 msgid ""
@@ -293,6 +275,10 @@ msgid ""
 "licenses</a>: the Apache 2.0 license, which has a clause to prevent "
 "treachery with patents."
 msgstr ""
+"Ou você poderia mencionar a licença sem copyleft que <a href=\"/licenses/"
+"license-recommendations.html\">nós recomendamos sobre as outras licenças sem "
+"copyleft</a>: a licença Apache 2.0, a qual possui uma cláusula para evitar "
+"traição com patentes."
 
 #. type: Content of: <p>
 msgid ""
@@ -300,6 +286,8 @@ msgid ""
 "always state which one: the &ldquo;original BSD license&rdquo; or the &ldquo;"
 "Modified BSD license&rdquo;."
 msgstr ""
+"Quando você quiser se referir especificamente a uma das licenças BSD, sempre "
+"especifique qual é: a “licença BSD original” ou a “licença BSD modificada”."
 
 #. type: Content of: <p>
 msgid ""
@@ -308,11 +296,20 @@ msgid ""
 "license.&rdquo; It is a lax, noncopyleft free license, compatible with the "
 "GNU GPL, much like the modified BSD license."
 msgstr ""
+"Posteriormente, uma terceira variante de licença BSD foi introduzida, com "
+"apenas as primeiras duas de quatro cláusulas da licença BSD. Nós a chamamos "
+"de “licença FreeBSD”. Ela é uma licença livre, leniente, sem copyleft, "
+"compatível com a GNU GPL e muito parecida com a licença BSD modificada."
 
 #. TRANSLATORS: Use space (SPC) as msgstr if you don't have notes.
 #. type: Content of: <div>
 msgid "*GNUN-SLOT: TRANSLATOR'S NOTES*"
-msgstr " "
+msgstr ""
+"<b>Nota do tradutor</b>:\n"
+"<ol>\n"
+"<li id=\"TransNote1\"><i>ad absurdum</i> significa, em latim, “ao absurdo”.</"
+"li>\n"
+"</ol>"
 
 # type: Content of: <div><p>
 #. type: Content of: <div><div><p>
@@ -356,18 +353,14 @@ msgstr ""
 "envio de traduções das páginas desse site."
 
 #. type: Content of: <div><p>
-#, fuzzy
 msgid ""
 "Copyright &copy; 1998, 1999, 2001, 2003, 2007, 2013, 2014, 2015 Free "
 "Software Foundation, Inc."
-msgstr "Copyright &copy; 1998, 1999, 2001 Free Software Foundation, Inc."
+msgstr ""
+"Copyright &copy; 1998, 1999, 2001, 2003, 2007, 2013, 2014, 2015 Free "
+"Software Foundation, Inc."
 
 #. type: Content of: <div><p>
-#, fuzzy
-#| msgid ""
-#| "This page is licensed under a <a rel=\"license\" href=\"http://"
-#| "creativecommons.org/licenses/by-nd/4.0/\">Creative Commons Attribution-"
-#| "NoDerivatives 4.0 International License</a>."
 msgid ""
 "This page is licensed under a <a rel=\"license\" href=\"http://"
 "creativecommons.org/licenses/by-nd/4.0/\">Creative Commons Attribution-"
@@ -382,7 +375,9 @@ msgstr ""
 msgid "*GNUN-SLOT: TRANSLATOR'S CREDITS*"
 msgstr ""
 "Traduzido por: Hilton Fernandes <a href=\"mailto:fernandesh@yahoo.com\">&lt;"
-"fernandesh@yahoo.com&gt;</a>"
+"fernandesh@yahoo.com&gt;</a>, 2002;\n"
+"Rafael Fontenelle <a href=\"mailto:rafaelff@gnome.org\">&lt;rafaelff@gnome."
+"org&gt;</a>, 2017"
 
 # type: Content of: <div><p>
 #.  timestamp start 
@@ -396,5 +391,5 @@ msgstr "Última atualização: "
 #~ "troublesome advertising clause."
 #~ msgstr ""
 #~ "Você tambêm pode ajudar a esclarecer o problema, se passar a dizer que "
-#~ "uma licença segue o \"estilo BSD\" apenas se ela seguir a antiga licença "
-#~ "do BSD, com sua problemática cláusula de anúncio."
+#~ "uma licença segue o “estilo BSD” apenas se ela seguir a antiga licença do "
+#~ "BSD, com sua problemática cláusula de anúncio."